;  
;  p pp
TMR0            EQU     01h
PC              EQU     02h
VRCON           EQU		9FH
STATUS          EQU     03h
FSR             EQU     04h
OPTIO	        EQU		81h
INTCON			EQU		0Bh
TXSTA 			EQU		98h	;    
RCSTA			EQU		18h	;     
SPBRG			EQU		99h				;   USART
TXREG			EQU		19h 			;   USART
RCREG			EQU		1Ah				;   USART
PIR1			EQU		0Ch				;   
EEADR			EQU		9Bh	; EEPROM
EEDATA			EQU		9Ah	; EEPROM
EECON1			EQU		9Ch	;
EECON2			EQU		9Dh	;		
; pp /
SINPORT         EQU     05h
DATAPORT        EQU     06h
; 
NUMCATOD        EQU     20h 			; 
ED				equ     21h				;
DES             equ     22h				;
SOT             equ     23h				;
PROBEL          equ     24h				; (4 )
NUM             equ     25h				; 
VOL				EQU     26h				; 
ADR				EQU		27h 			;  
KLAV1			EQU		28h
KLAV2			EQU		29h
KLAV3			EQU		2Ah
KLAV4			EQU		2Bh
KLAV5			EQU		2Ch
KLAV1A			EQU		34h
KLAV2A			EQU		35h
KLAV3A			EQU		36h
KLAV4A			EQU		37h
KLAV1B			EQU		38h
KLAV2B			EQU		39h
KLAV3B			EQU		3Ah
KLAV4B			EQU		3Bh		
SIMVOL          EQU		2Dh		;     
PERTEA1         EQU		2Eh				;   TEA
PERTEA2			EQU		2Fh
PERTEA3			EQU		30h
PRTEA1          EQU		31h				;   TEA
PRTEA2			EQU		32h
PRTEA3			EQU		33h
KANAL			EQU		34h		;     0-9

;  
FML0			EQU		00h		                ;  0-9 
FCT0			EQU		01h 
FML1			EQU		02h
FCT1			EQU		03h 
FML2			EQU		04h
FCT2			EQU 	05h
FML3			EQU		06h
FCT3			EQU 	07h
FML4			EQU		08h
FCT4			EQU 	09h
FML5			EQU		0Ah
FCT5			EQU 	0Bh
FML6			EQU		0Ch
FCT6			EQU 	0Dh
FML7			EQU		0Eh
FCT7			EQU 	0Fh
FML8			EQU		10h
FCT8			EQU 	11h
FML9			EQU		12h
FCT9			EQU 	13h
;  pp STATUS
C	            EQU     0h
DC              EQU     1h
Z               EQU     2h
PD              EQU     3h
TO              EQU     4h
RP              EQU     5h
; p pp
TRISA           EQU     85h
TRISB           EQU     86h
VRCON			EQU		9Fh   
;    p /
INITA           EQU     B'00000100'
INITB           EQU     B'00000000'
;
C0 				equ	    b'11111100'
C1				EQU		B'01100000'
C2				EQU		B'11011010'
C3				EQU		B'11110010'
C4				EQU		B'01100110'
C5				EQU		B'10110110'
C6				EQU		B'10111110'
C7				EQU		B'11100000'
C8				EQU		B'11111110'
C9				EQU		B'11110110'
CP				EQU		B'11101100'
TIRE			EQU		B'00000010'
CU				EQU		B'01111100'
CH				EQU		B'01101110'
CG				EQU		B'10111100'
CL				EQU		B'00011100'
IP				EQU		B'00100000'
C0T				equ	    b'11111101'
C1T				EQU		B'01100001'
C2T				EQU		B'11011011'
C3T				EQU		B'11110011'
C4T				EQU		B'01100111'
C5T				EQU		B'10110111'
C6T				EQU		B'10111111'
C7T				EQU		B'11100001'
C8T				EQU		B'11111111'
C9T				EQU		B'11110111'
II				EQU		B'00101000'
IL				EQU		B'00001000'
Re				EQU		B'11110111'      
WK				EQU		B'00000010'
WI              EQU		B'00000001'
Rk				EQU		B'00001011'
CEte			EQU		B'00010011'

;;  
;;   
	ORG     0
	GOTO    BEGIN;
	ORG     100h
BEGIN

				BSF     STATUS,RP           ;  1
				MOVLW	INITA
				CLRF	TRISA				;A     2(Uref)
				MOVWF	TRISA
				CLRF	TRISB				;  
                MOVLW	B'11000000'			;  2  1,25
				MOVWF	VRCON	
				BCF     STATUS,RP           ;  0  
				MOVLW	B'00000011'			;SINPORT Wk=1,Wi=1, Rk=0,CEte=0
				MOVWF	SINPORT
				MOVLW	B'11000000'
				MOVWF	VOL                 ;  VOL   
				MOVLW	B'11011111'			;  
				MOVWF	DATAPORT
				MOVLW	B'11111110'
				MOVWF	NUMCATOD
				MOVLW	B'01010101'
				MOVWF	PERTEA1
				MOVLW	B'10101010'
				MOVWF	PERTEA2
				MOVLW	B'11011011'
				MOVWF	PERTEA3
				CLRF	SIMVOL
				CLRF	ED
				CLRF	DES
				CLRF	SOT
				CLRF	PROBEL
				CLRF	NUM	
				CLRF	KLAV1
				CLRF	KLAV2
				CLRF	KLAV3

;  ()
CATOD			BSF     STATUS,RP           ;  1 
				CLRF	TRISB				;   
				BCF     STATUS,RP           ;  0				
				MOVLW	B'11011110'
				MOVWF	DATAPORT
				MOVLW	WK					;   0
				MOVWF	SINPORT				;				I  
				MOVLW	B'00000011'			;				I     
				MOVWF	SINPORT				;				I  
				MOVF	ED,0
				MOVWF	SIMVOL
				CALL	DECODER
				MOVF	SIMVOL,0
				MOVWF	DATAPORT
				MOVLW	WI					;   
				MOVWF	SINPORT				;				I  
				MOVLW	B'00000011'			;				I     
				MOVWF	SINPORT				;				I  
				BSF     STATUS,RP           ;  1     
				COMF	TRISB				;   
  				CLRF	OPTIO				;                  
				BCF     STATUS,RP           ;  0
				MOVF	KLAV1A,0			;     
				MOVWF	KLAV1B		
				MOVF	KLAV1,0				;
				MOVWF	KLAV1A					 
				MOVLW	Rk					;				I     
				MOVWF	SINPORT				;				I 
				MOVF	DATAPORT,0
				MOVWF	KLAV1
				COMF	KLAV1,1				;=1
				MOVLW	B'0000011'			;
				MOVWF	SINPORT

				BSF     STATUS,RP           ;  1   
				CLRF	TRISB				;   
				BCF     STATUS,RP           ;  0		 			
				MOVLW	B'11011101'				
				MOVWF	DATAPORT
				MOVLW	WK					;   0
				MOVWF	SINPORT				;				I  
				MOVLW	B'00000011'			;				I     
				MOVWF	SINPORT				;				I  
				MOVF	DES,0
				MOVWF	SIMVOL
				CALL	DECODER
				MOVF	SIMVOL,0
				MOVWF	DATAPORT
				MOVLW	WI					;   
				MOVWF	SINPORT				;				I  
				MOVLW	B'00000011'			;				I     
				MOVWF	SINPORT				;				I  
				BSF     STATUS,RP           ;  1     
				COMF	TRISB				;   
  				CLRF	OPTIO				;                  
				BCF     STATUS,RP           ;  0
				MOVF	KLAV2A,0			;     
				MOVWF	KLAV2B		
				MOVF	KLAV2,0				;
				MOVWF	KLAV2A					 	 
				MOVLW	Rk					;				I     
				MOVWF	SINPORT				;				I 
				MOVF	DATAPORT,0
				MOVWF	KLAV2
				COMF	KLAV2,1				;=1
				MOVLW	B'00000011'			;
				MOVWF	SINPORT	
	
				BSF     STATUS,RP           ;  1
				CLRF	TRISB				;   
				BCF     STATUS,RP           ;  0
				MOVLW	B'11011011'				
				MOVWF	DATAPORT
				MOVLW	WK					;   
				MOVWF	SINPORT				;				I  
				MOVLW	B'00000011'			;				I     
				MOVWF	SINPORT				;				I  
				MOVF	SOT,0
				MOVWF	SIMVOL
				CALL	DECODER
				MOVF	SIMVOL,0
				MOVWF	DATAPORT
				MOVLW	WI					;   
				MOVWF	SINPORT				;				I  
				MOVLW	B'00000011'			;				I     
				MOVWF	SINPORT				;				I  
				BSF     STATUS,RP           ;  1     
				COMF	TRISB				;   
  				CLRF	OPTIO				;                  
				BCF     STATUS,RP           ;  0
				MOVF	KLAV3A,0			;     
				MOVWF	KLAV3B		
				MOVF	KLAV3,0				;
				MOVWF	KLAV3A					 	 
				MOVLW	Rk					;		I     
				MOVWF	SINPORT				;		I 
				MOVF	DATAPORT,0
				MOVWF	KLAV3
				COMF	KLAV3,1				;=1
				MOVLW	B'00000011'			;
				MOVWF	SINPORT

				BSF     STATUS,RP           ;   1
				CLRF	TRISB				;   
				BCF     STATUS,RP           ;  0
				MOVLW 	B'11010111'				
				MOVWF	DATAPORT
				MOVLW	WK					;   
				MOVWF	SINPORT				;			I  
				MOVLW	B'00000011'			;			I     
				MOVWF	SINPORT				;			I  
				MOVF	PROBEL,0
				MOVWF	SIMVOL
				CALL	DECODER
				MOVF	SIMVOL,0
				MOVWF	DATAPORT
				MOVLW	WI					;   
				MOVWF	SINPORT				;				I  
				MOVLW	B'00000011'			;				I     
				MOVWF	SINPORT				;				I  
				BSF     STATUS,RP           ;  1     
				COMF	TRISB				;   
  				CLRF	OPTIO				;                  
				BCF     STATUS,RP           ;  0
				MOVF	KLAV4A,0			;     
				MOVWF	KLAV4B		
				MOVF	KLAV4,0				;
				MOVWF	KLAV4A					 	 
				MOVLW	Rk					;		I     
				MOVWF	SINPORT				;		I 
				MOVF	DATAPORT,0
				MOVWF	KLAV4
				COMF	KLAV4,1				;=1
				MOVLW	B'00000011'			;
				MOVWF	SINPORT

				BSF     STATUS,RP           ;  1
				CLRF	TRISB				;   
				BCF     STATUS,RP           ;  0
				MOVLW	B'11001111'				
				MOVWF	DATAPORT
				MOVLW	WK					;	I     0
				MOVWF	SINPORT				;	I  
				MOVLW	B'00000011'			;	I     
				MOVWF	SINPORT				;	I  
				MOVF	NUM,0
				MOVWF	SIMVOL
				CALL	DECODER
				MOVF	SIMVOL,0
				MOVWF	DATAPORT
				MOVLW	WI					;	I   
				MOVWF	SINPORT				;	I  
				MOVLW	B'00000011'			;	I     
				MOVWF	SINPORT				;	I  
				BSF     STATUS,RP        	;  1
				COMF	TRISB				;   
  				CLRF	OPTIO		;                  
				BCF     STATUS,RP           ;  0


				BSF     STATUS,RP           ;  1 
				CLRF	TRISB				;   
				BCF     STATUS,RP           ;  0	I 
				MOVLW	B'11011111'				
				MOVWF	DATAPORT
				MOVLW	WK					;	I     0
				MOVWF	SINPORT				;	I  
				MOVLW	B'00000011'			;	I     
				MOVWF	SINPORT				;	I  
				MOVLW	WI					;	I   
				MOVWF	SINPORT				;	I  
				MOVLW	B'00000011'			;	I     
				MOVWF	SINPORT				;	I  	 
	
				GOTO	ZAGRUZKA

DECODER			MOVF	SIMVOL,0
				BTFSC	STATUS,Z
				GOTO	S0
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	S1
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	S2
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	S3
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	S4
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	S5
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	S6
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	S7
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	S8
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	S9
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	SA
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	SB
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	SC
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	SD
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	SE
				DECF	SIMVOL,1
				BTFSC	STATUS,Z
				GOTO	SF
				GOTO	SF

S0				MOVLW	C0
				MOVWF	SIMVOL
				RETURN
S1				MOVLW	C1
				MOVWF	SIMVOL
				RETURN
S2				MOVLW	C2
				MOVWF	SIMVOL
				RETURN	
S3				MOVLW	C3
				MOVWF	SIMVOL
				RETURN	
S4				MOVLW	C4
				MOVWF	SIMVOL
				RETURN	
S5				MOVLW	C5
				MOVWF	SIMVOL
				RETURN	
S6				MOVLW	C6
				MOVWF	SIMVOL
				RETURN	
S7				MOVLW	C7
				MOVWF	SIMVOL
				RETURN	
S8				MOVLW	C8
				MOVWF	SIMVOL
				RETURN	
S9				MOVLW	C9
				MOVWF	SIMVOL
				RETURN	
SA				MOVLW	TIRE
				MOVWF	SIMVOL
				RETURN	
SB				MOVLW	CU
				MOVWF	SIMVOL
				RETURN
SC				MOVLW	CH
				MOVWF	SIMVOL
				RETURN	
SD				MOVLW	CG
				MOVWF	SIMVOL
				RETURN	
SE				MOVLW	CL
				MOVWF	SIMVOL
				RETURN	
SF				MOVLW	IP
				MOVWF	SIMVOL
				RETURN

ZAGRUZKA		BCF		STATUS,RP
				MOVF	KLAV1,0
				MOVWF	ED
				MOVF	KLAV2,0
				MOVWF	DES
      			MOVF	KLAV3,0
				MOVWF	SOT
				MOVF	KLAV4,0
				MOVWF	PROBEL
				MOVWF	NUM

	

; USART
PEREDCHA		BSF     STATUS,RP           ;  1
				CLRF	TRISB
				MOVLW	INITA
				MOVWF	TRISA				;A     2(Uref)
				MOVLW	B'00001001'			;  
				MOVWF	SPBRG
				MOVLW	B'10110000'			;  
				MOVWF	TXSTA

				BCF     STATUS,RP           ;  0
				NOP
				MOVLW	B'11111111'
				MOVWF	DATAPORT
				MOVLW	WK					;	I    
				MOVWF	SINPORT				;	I  
				MOVLW	B'00000011'			;	I     
				MOVWF	SINPORT				;	I  

				BSF     STATUS,RP           ;  1
				MOVLW	B'00000110'			;  1,2  
				MOVWF	TRISB
				BCF     STATUS,RP           ;  0
				MOVLW	B'10000000'			;  1,2  D, CLC 			
				MOVWF	RCSTA
				MOVLW	B'00010011'			; CEte
				MOVWF	SINPORT
				MOVF	PERTEA1,0		;   
				MOVWF	TXREG
				BSF     STATUS,RP           ;  1
CIKL			BTFSS	TXSTA,1h
				GOTO	CIKL
				BCF     STATUS,RP           ;  0
				MOVF	PERTEA2,0			; 2  
				MOVWF	TXREG
				BSF     STATUS,RP           ;  1
CIKL1			BTFSS	TXSTA,1h
				GOTO	CIKL1
				BCF     STATUS,RP           ;  0
				MOVF	PERTEA3,0			; 3  
				MOVWF	TXREG
				BSF     STATUS,RP           ;  1
CIKL2			BTFSS	TXSTA,1h
				GOTO	CIKL2
				CLRF	TRISB				;    	

				BCF     STATUS,RP			;  0
 				MOVLW	B'00000011'			; CEte
				MOVWF	SINPORT 
				CLRF	RCSTA

				MOVLW	B'11011111'
				MOVWF	DATAPORT
				MOVLW	WK					;I    W/Rte
				MOVWF	SINPORT				;	I  
				MOVLW	B'00000011'			;	I     
				MOVWF	SINPORT				;	I  
; USART          
PRIEM 			BSF     STATUS,RP           ;  1
				CLRF	TRISB               ;   
				MOVLW	B'00001001'			;  
				MOVWF	SPBRG
				MOVLW	B'10010000'			;  
				MOVWF	TXSTA

				BCF     STATUS,RP           ;  0 
				MOVLW	B'11011111'
				MOVWF	DATAPORT
				MOVLW	WK					;	I  W/Rte=0
				MOVWF	SINPORT				;	I  
				MOVLW	B'00000011'			;	I     
				MOVWF	SINPORT				;	I  

				BSF     STATUS,RP           ;  1
				MOVLW	B'00000110'			;  1,2  
				MOVWF	TRISB
				BCF     STATUS,RP           ;  0

				MOVLW	B'10110000'		;  1,2    D,CLC 			
				MOVWF	RCSTA
				MOVLW	B'00010011'			; CEte
				MOVWF	SINPORT

LOOP1			BTFSS	PIR1,5h				;  	
				GOTO	LOOP1
				MOVF	RCREG,0				;   PRTEA1
				MOVWF	PRTEA1

LOOP2			BTFSS	PIR1,5h				;  	
				GOTO	LOOP2
				MOVF	RCREG,0				;   PRTEA2
				MOVWF	PRTEA2

LOOP3			BTFSS	PIR1,5h				;  	
				GOTO	LOOP3
				MOVLW	B'00000011'			; CEte
				MOVWF	SINPORT
				MOVF	RCREG,0				;   PRTEA3
				MOVWF	PRTEA3
			
				CLRF	RCSTA				;  
				BSF     STATUS,RP           ;  1
				CLRF	TRISB				;   
				CLRF	TXSTA				;  
				GOTO	CATOD
										
				END
